const Discord = require("discord.js");
const bot = new Discord.Client();
const { Webhook, MessageBuilder } = require('discord-webhook-node');
const npmpp = require("npm-api");
const Repo = require("npm-api/lib/models/repo");
let prefix = ""
let cmddelete = false
let version = "1.0.4"
const repo = new Repo('discordjseasier');
const slashes = []

repo.package()
    .then(function (pkg) {
        if (version === pkg.version) return;
        else console.log("[Discord]: There is a new Update! Please do: npm update discordjseasier to see the new features!")
    }, function (err) {
        console.error(err);
    });

bot.on("ready", () => {
    console.log("[Discord]: Bot Online!")
})

async function command(command) {
    bot.on("message", async message => {
        if (message.content === (prefix + command)) {
            if (cmddelete === true) {
                message.delete()
            }
            message.channel.send("test")
        }
    })
}

async function slashcreate(title, description, message, guildID, botID) {
    bot.api.applications(botID).guilds(guildID).commands.post({
        data: {
            name: title,
            description: description
        }
    }).catch(err => {
        if (err) {
            console.log("[Discord]: The bot must have the applications.commands scope in the server to create slash commands!")
        }
    })
        .then(() => {
            slashes.push(title + " " + message)
        })
}

async function globalslashcreate(title, description, message, botID) {
    bot.api.applications(botID).commands.post({
        data: {
            name: title,
            description: description
        }
    }).catch(err => {
        if (err) {
            console.log("[Discord]: The bot must have the applications.commands scope in the server: " + guildID.name)
        }
    })
        .then(() => {
            if (slashes.includes(title + " " + message)) return null;
            slashes.push(title + " " + message)
        })
}

bot.ws.on('INTERACTION_CREATE', async interaction => {
    let cmdsent = false
    slashes.forEach(slash => {
        const command = interaction.data.name.toLowerCase();
        const args = interaction.data.options;
        const cmd = slash.split(" ").slice(0, 1).join(" ")
        const message = slash.split(" ").slice(1).join(" ")

        if (command === cmd) {
            bot.api.interactions(interaction.id, interaction.token).callback.post({
                data: {
                    type: 4,
                    data: {
                        content: message,
                    }
                }
            })
            cmdsent = true
        }
    })
    if (cmdsent === false) {
        bot.api.interactions(interaction.id, interaction.token).callback.post({
            data: {
                type: 4,
                data: {
                    content: "It looks like this slash command got deleted, check back later to see if it was added again!\n\nAutomated message by: DiscordJSEasier"
                }
            }
        })
    } else {
        cmdsent = false
    }
})

async function boot(token) {
    bot.login(token).catch(err => {
        if (err) {
            console.log("[Discord]: Invalid Bot Token.");
        }
    })
}

async function ping() {
    bot.on("message", async message => {
        if (message.content.startsWith(prefix + "ping")) {
            if (cmddelete === true) {
                message.delete()
            }
            let ms = Date.now() - message.createdTimestamp
            let ping = new Discord.MessageEmbed()
                .setAuthor(message.author.tag, message.author.displayAvatarURL({ dynamic: true }))
                .setTitle("Ping")
                .setDescription("API: `" + bot.ws.ping + "ms`\nBot: `" + ms + "ms`")
                .setColor("BLUE")
            message.channel.send(ping)
        }
    })
}

async function prefixset(set) {
    prefix = set
}

async function echo() {
    bot.on("message", async message => {
        if (message.content.startsWith(prefix + "echo")) {
            if (cmddelete === true) {
                message.delete()
            }
            message.channel.send(message.content.split(" ").slice(1).join(" "))
        }
    })
}

async function sendwebhook(url, message) {
    const hook = new Webhook(url);
    hook.send(message);
}

async function cmddeletee(bool) {
    if (bool === true) {
        cmddelete = true;
    } else {
        cmddelete = false;
    }
}

async function embed(author, title, description, footer, color, thumbnail, image) {
    let embed2 = new Discord.MessageEmbed()
        .setAuthor(author)
        .setTitle(title)
        .setDescription(description)
        .setFooter(footer)
        .setThumbnail(thumbnail)
        .setImage(image)
        .setColor(color)

    return embed2
}

module.exports.boot = boot
module.exports.command = command
module.exports.prefix = prefixset
module.exports.echo = echo
module.exports.cmddelete = cmddeletee
module.exports.webhook = sendwebhook
module.exports.embed = embed
module.exports.ping = ping
module.exports.slashcreate = slashcreate
module.exports.globalslashcreate = globalslashcreate